net.sourceforge.jnlp.security

## Class SecurityDialog

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Dialog
        - - javax.swing.JDialog
          - - net.sourceforge.jnlp.security.SecurityDialog

All Implemented Interfaces:
  java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.RootPaneContainer, javax.swing.WindowConstants

    public class SecurityDialog
    extends javax.swing.JDialog

Provides methods for showing security warning dialogs for a wide range of JNLP security issues. Note that the security dialogs should be running in the secure AppContext - this class should not be used directly from an applet or application. See `SecurityDialogs` for a way to show security dialogs.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JDialog

`javax.swing.JDialog.AccessibleJDialog`

### Nested classes/interfaces inherited from class java.awt.Dialog

`java.awt.Dialog.AccessibleAWTDialog, java.awt.Dialog.ModalExclusionType, java.awt.Dialog.ModalityType`

### Nested classes/interfaces inherited from class java.awt.Window

`java.awt.Window.AccessibleAWTWindow`

### Nested classes/interfaces inherited from class java.awt.Container

`java.awt.Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

### Field Summary

### Fields inherited from class javax.swing.JDialog

`accessibleContext, rootPane, rootPaneCheckingEnabled`

### Fields inherited from class java.awt.Dialog

`DEFAULT_MODALITY_TYPE`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface javax.swing.WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Method Summary

Methods
`void` `addActionListener(java.awt.event.ActionListener listener)` Adds an `ActionListener` which will be notified if the user makes a choice using this SecurityDialog.
`void` `dispose()` Called when the SecurityDialog is hidden - either because the user made a choice (Ok, Cancel, etc) or closed the window
`SecurityDialogs.AccessType` `getAccessType()`
`java.security.cert.X509Certificate` `getCert()`
`CertVerifier` `getCertVerifier()`
`JNLPFile` `getFile()`
`java.lang.Object` `getValue()`
`boolean` `isInitialized()` Returns if this dialog has been fully initialized yet.
`void` `notifySelectionMade()` Notify all the listeners that the user has made a decision using this security dialog.
`boolean` `requiresSignedJNLPWarning()`
`protected void` `setSystemLookAndFeel()` Updates the look and feel of the window to be the system look and feel
`protected void` `setValue(java.lang.Object value)`
`static void` `showCertInfoDialog(CertVerifier certVerifier, SecurityDialog parent)` Displays CertPath information in a readable table format.
`static void` `showMoreInfoDialog(CertVerifier certVerifier, SecurityDialog parent)` Shows more information regarding jar code signing
`static void` `showSingleCertInfoDialog(java.security.cert.X509Certificate c, javax.swing.JDialog parent)` Displays a single certificate's information.

### Methods inherited from class javax.swing.JDialog

`addImpl, createRootPane, dialogInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

### Methods inherited from class java.awt.Dialog

`addNotify, getModalityType, getTitle, hide, isModal, isResizable, isUndecorated, setModal, setModalityType, setResizable, setTitle, setUndecorated, setVisible, show, toBack`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getGraphicsConfiguration, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOwnedWindows, getOwner, getOwnerlessWindows, getToolkit, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isShowing, pack, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paint, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, setBackground, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### isInitialized

    public boolean isInitialized()

Returns if this dialog has been fully initialized yet.

Returns:
  true if this dialog has been initialized, and false otherwise.

#### showMoreInfoDialog

    public static void showMoreInfoDialog(CertVerifier certVerifier,
                          SecurityDialog parent)

Shows more information regarding jar code signing

Parameters:
  `certVerifier` - the JarCertVerifier used to verify this application
  `parent` - the parent option pane

#### showCertInfoDialog

    public static void showCertInfoDialog(CertVerifier certVerifier,
                          SecurityDialog parent)

Displays CertPath information in a readable table format.

Parameters:
  `certVerifier` - the JarCertVerifier used to verify this application
  `parent` - the parent option pane

#### showSingleCertInfoDialog

    public static void showSingleCertInfoDialog(java.security.cert.X509Certificate c,
                                javax.swing.JDialog parent)

Displays a single certificate's information.

Parameters:
  `c` - the X509 certificate.
  `parent` - the parent pane.

#### getAccessType

    public SecurityDialogs.AccessType getAccessType()

#### getFile

    public JNLPFile getFile()

#### getCertVerifier

    public CertVerifier getCertVerifier()

#### getCert

    public java.security.cert.X509Certificate getCert()

#### setValue

    protected void setValue(java.lang.Object value)

#### getValue

    public java.lang.Object getValue()

#### dispose

    public void dispose()

Called when the SecurityDialog is hidden - either because the user made a choice (Ok, Cancel, etc) or closed the window

Overrides:
  `dispose` in class `java.awt.Window`

#### setSystemLookAndFeel

    protected void setSystemLookAndFeel()

Updates the look and feel of the window to be the system look and feel

#### notifySelectionMade

    public void notifySelectionMade()

Notify all the listeners that the user has made a decision using this security dialog.

#### addActionListener

    public void addActionListener(java.awt.event.ActionListener listener)

Adds an `ActionListener` which will be notified if the user makes a choice using this SecurityDialog. The listener should use `getValue()` to actually get the user's response.

#### requiresSignedJNLPWarning

    public boolean requiresSignedJNLPWarning()